Summary: GNU C Compiler
Name: gcc
%define version 2.7.2.3
Version: %{version}
Release: 14
Copyright: GPL
Group: Development/Languages
Source: ftp://prep.ai.mit.edu/pub/gnu/gcc-%{version}.tar.gz
Patch1: gcc-2.7.2-make.patch
Patch2: gcc-2.7.2.sparc.patch
Patch3: ftp://atheist.tamu.edu/pub/richard/linux/axp/rth-gcc-2.7.2-960814.diff.gz
Patch4: gcc-2.7.2-pg.patch
Patch5: gcc-2.7.2-flow.patch
Patch6: ftp://ftp.redhat.com/pub/alphabits/rth-gcc-2.7.2-961121.diff.gz
Patch7: gcc-2.7.2.sparc.patch2
Patch8: gcc-2.7.2.3-glibc2.patch
Patch9: gcc-2.7.2-alpha-ra.patch
Requires: binutils
Prereq: /sbin/install-info
Buildroot: /var/tmp/gcc-root
Exclusivearch: i386
Summary(de): GNU-C-Compiler 
Summary(fr): Compilateur C de GNU
Summary(tr): GNU C derleyicisi

%description
The GNU C compiler -- a full featured ANSI C compiler, with support
for K&R C as well. GCC provides many levels of source code error
checking tradionaly provided by other tools (such as lint), produces
debugging information, and can perform many different optimizations to
the resulting object code. This contains the back end for C++ and 
Objective C compilers as well.

%description -l de
Der GNU-C-Compiler, ein ANSI-C-Compiler mit komplettem Funktions-
umfang sowie Untersttzung fr K&R. GCC bietet viele Ebenen der
Quell-Code-Fehlerprfung, wie sie frher durch separate Tools bereitgestellt
wurde (etwa lint), produziert Debug-Infos und ist in der Lage, viele
verschiedene Optimierungen am resultierenden Objektcode auszufhren. 
Enthlt auch das Backend fr C++ und Objective-C-Compiler.

%description -l fr
Le compilateur C GNU -- un compilateur C ANSI complet, avec un support
pour la norme K&R. GCC fournit de nombreux niveaux d'erreurs donns par
des outils extrieurs (comme lint), produit des informations de dbogage,
et peut raliser diffrentes optimisations sur le code objet produit.
Il contient aussi le back-end pour les compilateurs Objective C et C++.

%description -l tr
GNU C derleyicisi, K&R C destei olan ve ANSI C'nin btn zelliklerine sahip
bir derleyicidir. Normalde baka aralarn (rnein lint) yapt kaynak kodu
dzeyindeki pek ok hata denetimini gerekletirir, hata ayklama bilgisi
retebilir ve sonu olarak ortaya kan ara kod zerinde birok optimizasyon
uygulayabilir.

%prep
%setup -q
%patch1 -p1 -b .rh

%ifarch sparc alpha
%patch2 -p1
%patch3 -p1
%patch4 -p0
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1 -b .glibc2
%patch9 -p0 -b .alphara
%endif

%build
 ./configure --prefix=/usr \
	--local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ \
	${RPM_ARCH}-redhat-linux 

make LANGUAGES=c CFLAGS="-O2"
make stage1
make CC="stage1/xgcc -Bstage1/" CFLAGS="-O2" LDFLAGS="-s"
make stage2
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O2" LDFLAGS="-s"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/{bin,lib,info,man}
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O2" LDFLAGS="-s" install \
	prefix=$RPM_BUILD_ROOT/usr

rm -f $RPM_BUILD_ROOT/usr/info/cpp.info* $RPM_BUILD_ROOT//usr/info/dir
gzip -n -9f $RPM_BUILD_ROOT/usr/info/gcc.info*
ln -sf gcc $RPM_BUILD_ROOT/usr/bin/cc
rm -rf $RPM_BUILD_ROOT/usr/lib/gcc-lib/${RPM_ARCH}-redhat-linux/*/include/objc

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/install-info /usr/info/gcc.info.gz /usr/info/dir --entry="* gcc: (gcc).                   The GNU C compiler."

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete /usr/info/gcc.info.gz /usr/info/dir --entry="* gcc: (gcc).                   The GNU C compiler."
fi

%files
%defattr(-,root,root)
%doc NEWS PROBLEMS
%ifarch i386
/usr/bin/gcc
/usr/bin/cc
%endif
/usr/bin/*-redhat-linux-gcc
/usr/man/man1/gcc.1
/usr/info/gcc.info*
%dir /usr/lib/gcc-lib/*-redhat-linux/*
%dir /usr/lib/gcc-lib/*-redhat-linux/*/include
/usr/lib/gcc-lib/*-redhat-linux/*/SYSCALLS.c.X
/usr/lib/gcc-lib/*-redhat-linux/*/cc1
/usr/lib/gcc-lib/*-redhat-linux/*/cpp
/usr/lib/gcc-lib/*-redhat-linux/*/libgcc.a
/usr/lib/gcc-lib/*-redhat-linux/*/specs
/usr/lib/gcc-lib/*-redhat-linux/*/include/*
/usr/lib/gcc-lib/*-redhat-linux/*/*.o

%changelog
* Wed Sep  2 1998 Jeff Johnson <jbj@redhat.com>
- eliminate gcc on sparc in RH5.2; sparclinux-2.0-980805 works with egcs.

* Mon Jul 13 1998 Jeff Johnson <jbj@redhat.com>
- sparc gets gcc/cc from egcs. someday ((after RH-5.2) i386 will too.

* Wed Jul  8 1998 Jeff Johnson <jbj@redhat.com>
- resurrect gcc for sparc kernel compiles.

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Thu Apr 30 1998 Cristian Gafton <gafton@redhat.com>
- use extensively CFLAGS="-O2" when building the compiler (this is known to
  help the fully compatible Cyrix chips (sic!) to run this beast)

* Mon Apr 20 1998 Cristian Gafton <gafton@redhat.com>
- better yet, ExclusiveArch: i386 is in effect

* Tue Apr 14 1998 Cristian Gafton <gafton@redhat.com>
- removed the c++ package as we are switching to egcs-c++
- idem for objc
- added buildroot
- alpha is exlcuded from the build. I don't know about sparc yet, so I leave
  it for this time

* Fri Oct 23 1997 Erik Troan <ewt@redhat.com>
- use ld-linux.so.2 on the sparc

* Fri Oct 10 1997 Erik Troan <ewt@redhat.com>
- build crtbegin* and crtend* on the sparc

* Mon Sep 29 1997 Erik Troan <ewt@redhat.com>
- added patch from rth to fix dump on alpha w/ building libg++

* Sun Sep 28 1997 Erik Troan <ewt@redhat.com>
- djb really made the crtbegin/end stuff in gcc-c-skel conditional on
  running on an i386 machine, not a !sparc machine; all changed was his
  comment
- added patch to use /lib/ld-linux.so.2 on the alpha

* Tue Sep 23 1997 Richard Henderson <rth@cygnus.com>
- Killed the glibc.patch and added sparc.patch2 to _really_ make
  libgcc.a be compiled with -fPIC.

* Fri Sep 19 1997 Donald Barnes <djb@redhat.com>
- added the glibc.patch so that libgcc.a is compiled with -fPIC
- added %ifarch i386 around crtbegin/end in gcc-c-skel

* Sun Sep 14 1997 Erik Troan <ewt@redhat.com>
- modified to use install-info

* Sun Aug 24 1997 Erik Troan <ewt@redhat.com>
- updated to gcc 2.7.2.3

* Thu Aug 21 1997 Erik Troan <ewt@redhat.com>
- fixed /lib/cpp patch to include redhat element

* Mon Jun 02 1997 Erik Troan <ewt@redhat.com>
- removed HJ's patch
- added patch from Ulrich Drepper to generate crt*.o
